766. 托普利茨矩阵

给你一个 m x n 的矩阵 matrix 。如果这个矩阵是托普利茨矩阵,返回 true ;否则,返回 false 。

如果矩阵上每一条由左上到右下的对角线上的元素都相同,那么这个矩阵是 托普利茨矩阵 。

示例 1:

输入:matrix = \[1,2,3,4,5,1,2,3,9,5,1,2]

输出:true

解释:

在上述矩阵中, 其对角线为:

"9", "5, 5", "1, 1, 1", "2, 2, 2", "3, 3", "4"。

各条对角线上的所有元素均相同, 因此答案是 True 。

示例 2:

输入:matrix = \[1,2,2,2]

输出:false

解释:

对角线 "1, 2" 上的元素不同。

提示:

m == matrix.length

n == matrixi.length

1 <= m, n <= 20

0 <= matrixij <= 99

思路:

正常来讲,最直观的做法应该就是第一行的每个元素开始向右下方遍历,看看是否相等;然后再沿着第一列开始向右下方遍历,看看是否相等。

但其实你仔细思考一下,就会发现,不需要这么麻烦,满足题意的最基本的条件,不就是每个元素都跟左上方的元素相等么(如果存在的话)。

而且第一行和第一列是不用判断的,因为不存在左上方元素。

代码:

c 复制代码
class Solution {
public:
    bool isToeplitzMatrix(vector<vector<int>>& matrix) {
        int n = matrix.size();
        int m = matrix[0].size();
        for(int i = 0 ; i < n ; i++){
            for(int j = 0 ; j < m ; j++){
                if(i-1 >= 0 && j-1 >= 0){
                    if(matrix[i-1][j-1] == matrix[i][j])
                        continue;
                    else
                        return false;
                }
            }
        }
        return true;
    }
};
相关推荐
dialect_8 小时前
KMP算法
开发语言·c++·算法
reikocao8 小时前
卡尔曼滤波的动态机制:P如何改变融合权重
算法
漂流瓶jz9 小时前
UVA-1612 猜名次 题解答案代码 算法竞赛入门经典第二版
数据结构·算法·题解·排序·aoapc·算法竞赛入门经典
吞下星星的少年·-·9 小时前
Div.2 CF 1130B题(构造,贪心)
算法·贪心·构造
是main不是漫11 小时前
【双指针——移动零】数组划分类题目的入门基石
c++·算法
深圳市快瞳科技有限公司12 小时前
野外鸟类AI识别落地实录:输入适配、结构化输出、去重聚合与置信度分流的工程实践
算法·计算机视觉·鸟类识别·鸟类ai识别·野外鸟类观测·林业调查
专注仿真13 小时前
梯度提升类(XFBoost)算法详解与代码实例
开发语言·人工智能·python·算法·大模型训练·控制算法
小豆庄13 小时前
视频遮罩追踪退场后ID撞号的排查—多目标场景下的失效
opencv·算法·bug·视频·python3.11
Tisfy14 小时前
LeetCode 3882.网格图中最小异或路径:动态规划
算法·leetcode·动态规划
D e re k ZH15 小时前
P5025 [SNOI2017] 炸弹
c++·算法